#ifndef DESH
#define DESH

#include <string.h>

class DES
{
public:
	DES();
	~DES();
	
	//:1628λkey
	//:Դ8λַ(key)
	//:private CreateSubKeychar SubKeys[16][48]
	void yxyDES2_InitializeKey(char* srcBytes);
	
	//:8λַ
	//:8λַ
	//:ܺprivate szCiphertext[16]
	//      ûͨCiphertextõ
	void yxyDES2_EncryptData(char* _srcBytes);
	
	//:16λʮַ
	//:16λʮַ
	//:ܺprivate szPlaintext[8]
	//      ûͨPlaintextõ
	void yxyDES2_DecryptData(char* _srcBytes);
	
	//:ⳤַ
	//:ⳤַ,
	//:ܺprivate szFCiphertextAnyLength[8192]
	//      ûͨCiphertextAnyLengthõ
	void yxyDES2_EncryptAnyLength(char* _srcBytes,unsigned int _bytesLength);
	
	//:ⳤʮַ
	//:ⳤַ,
	//:ܺprivate szFPlaintextAnyLength[8192]
	//      ûͨPlaintextAnyLengthõ
	void yxyDES2_DecryptAnyLength(char* _srcBytes,unsigned int _bytesLength);
	
	//:BytesBitsת,
	//:任ַ,Żָ,BitsС
	void yxyDES2_Bytes2Bits(char *srcBytes, char* dstBits, unsigned int sizeBits);
	
	//:BitsBytesת,
	//:任ַ,Żָ,BitsС
	void yxyDES2_Bits2Bytes(char *dstBytes, char* srcBits, unsigned int sizeBits);
	
	//:IntBitsת,
	//:任ַ,Żָ
	void yxyDES2_Int2Bits(unsigned int srcByte, char* dstBits);
	
	//:BitsHexת
	//:任ַ,Żָ,BitsС
	void yxyDES2_Bits2Hex(char *dstHex, char* srcBits, unsigned int sizeBits);
	
	//:BitsHexת
	//:任ַ,Żָ,BitsС
	void yxyDES2_Hex2Bits(char *srcHex, char* dstBits, unsigned int sizeBits);
	
	//szCiphertextInBinaryget
	char* yxyDES2_GetCiphertextInBinary();
	
	//szCiphertextInHexget
	char* yxyDES2_GetCiphertextInHex();
	
	//Ciphertextget
	char* yxyDES2_GetCiphertextInBytes();
	
	//Plaintextget
	char* yxyDES2_GetPlaintext();
	
	//CiphertextAnyLengthget
	char* yxyDES2_GetCiphertextAnyLength();
	
	//PlaintextAnyLengthget
	char* yxyDES2_GetPlaintextAnyLength();
	
	//:Կ
	//:PC1任56λַ
	//:char szSubKeys[16][48]
	void yxyDES2_CreateSubKey(char* sz_56key);
	
	//:DESеF,
	//:32λ,32λ,key(0-15)
	//:ڱ任32λ
	void yxyDES2_FunctionF(char* sz_Li,char* sz_Ri,unsigned int iKey);
	
	//:IP任
	//:ַ,ָ
	//:ıڶ
	void yxyDES2_InitialPermuteData(char* _src,char* _dst);
	
	//:32λչλ48λ,
	//:ԭ32λַ,չָ
	//:ıڶ
	void yxyDES2_ExpansionR(char* _src,char* _dst);
	
	//:,
	//:Ĳַ1,ַ2,,ָ
	//: ıĸ
	void yxyDES2_XOR(char* szParam1,char* szParam2, unsigned int uiParamLength, char* szReturnValueBuffer);
	
	//:S-BOX , ѹ,
	//:48λַ,
	//:ؽ:32λַ
	void yxyDES2_CompressFuncS(char* _src48, char* _dst32);
	
	//:IP任,
	//:任ַ,ָ
	//:ıڶ
	void yxyDES2_PermutationP(char* _src,char* _dst);

private:

	char szSubKeys[16][48];//1648λԿ
	char szCiphertextRaw[64]; //(64Bits) int 0,1
	char szPlaintextRaw[64]; //(64Bits) int 0,1
	char szCiphertextInBytes[8];//8λ
	char szPlaintextInBytes[8];//8λַ
	
	char szCiphertextInBinary[65]; //(64Bits) char '0','1',һλ'\0'
	char szCiphertextInHex[17]; //ʮ,һλ'\0'
	char szPlaintext[9];//8λַ,һλ'\0'
	
	char szFCiphertextAnyLength[8192];//ⳤ
	char szFPlaintextAnyLength[8192];//ⳤַ
};

#endif