#include"BsPhpClass.h"
#include"stdafx.h"
#define IsHexNum(c) ((c >= '0' && c <= '9') || (c >= 'A' && c <= 'F') || (c >= 'a' && c <= 'f'))
CString GetHWID() {
	char *pHardWareString = NULL;
	UINT Size = VMProtectGetCurrentHWID(NULL, 0);
	pHardWareString = new char[Size];
	VMProtectGetCurrentHWID(pHardWareString, Size);
	CString str(pHardWareString);
	return str;
}
inline BYTE toHex(const BYTE &x)
{
	return x > 9 ? x + 55 : x + 48;
}
CString Utf8ToStringT(LPSTR str)
{
	_ASSERT(str);
	USES_CONVERSION;
	WCHAR *buf;
	int length = MultiByteToWideChar(CP_UTF8, 0, str, -1, NULL, 0);
	buf = new WCHAR[length + 1];
	ZeroMemory(buf, (length + 1) * sizeof(WCHAR));
	MultiByteToWideChar(CP_UTF8, 0, str, -1, buf, length);

	return (CString(W2T(buf)));
}
CString UrlDecode(LPCTSTR url)
{
	_ASSERT(url);
	USES_CONVERSION;
	LPSTR _url = T2A(const_cast<LPTSTR>(url));
	int i = 0;
	int length = (int)strlen(_url);
	CHAR *buf = new CHAR[length];
	ZeroMemory(buf, length);
	LPSTR p = buf;
	char tmp[4];
	while (i < length)
	{
		if (i <= length - 3 && _url[i] == '%' && IsHexNum(_url[i + 1]) && IsHexNum(_url[i + 2]))
		{
			memset(tmp, 0, sizeof(tmp));
			memcpy(tmp, _url + i + 1, 2);
			sscanf(tmp, "%x", p++);
			i += 3;
		}
		else
		{
			*(p++) = _url[i++];
		}
	}
	return CString(buf);
	//return Utf8ToStringT(buf);
}
CString UrlEncode(CString sIn)
{
	CString sOut;

	const int nLen = sIn.GetLength() + 1;

	register LPBYTE pOutTmp = NULL;
	LPBYTE pOutBuf = NULL;
	register LPBYTE pInTmp = NULL;
	LPBYTE pInBuf = (LPBYTE)sIn.GetBuffer(nLen);
	BYTE b = 0;

	//alloc out buffer
	pOutBuf = (LPBYTE)sOut.GetBuffer(nLen * 3 - 2);//new BYTE [nLen  * 3];

	if (pOutBuf)
	{
		pInTmp = pInBuf;
		pOutTmp = pOutBuf;

		// do encoding
		while (*pInTmp)
		{
			if (isalnum(*pInTmp))
				*pOutTmp++ = *pInTmp;
			else
				if (isspace(*pInTmp))
					*pOutTmp++ = '+';
				else
				{
					*pOutTmp++ = '%';
					*pOutTmp++ = toHex(*pInTmp >> 4);
					*pOutTmp++ = toHex(*pInTmp % 16);
				}
			pInTmp++;
		}
		*pOutTmp = '\0';
		//sOut=pOutBuf;
		//delete [] pOutBuf;
		sOut.ReleaseBuffer();
	}
	sIn.ReleaseBuffer();
	return sOut;
}
CString GetTime() {
	CString Time;
	CTime tm; tm = CTime::GetCurrentTime();
	Time = tm.Format("%Y-%m-%d %X");
	return Time;
}
CString Login(CString UserName, CString PassWorld) {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=login.lg&date=" + GetTime() + "&mutualkey=" + MesKey + "&user=" + UserName + "&pwd=" + PassWorld + "&BSphpSeSsL=" + SeSsL+"&maxoror="+ PcHWID));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter=" + Data));
	Http.HttpPost(ServerUrl, Data, RetData);
	return RetData.c_str();;
}
BOOL Internet() {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=internet.in&date="+GetTime()+"&mutualkey="+ MesKey));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter="+Data));
	Http.HttpPost(ServerUrl,Data, RetData);
	if (RetData == "1") {
		return true;
	}
	return false;
}
CString GetGG() {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=gg.in&date=" + GetTime() + "&mutualkey=" + MesKey+"&BSphpSeSsL="+ SeSsL));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter=" + Data));
	Http.HttpPost(ServerUrl, Data, RetData);
	return  RetData.c_str();
}
CString GetBSphpSeSsL() {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=BSphpSeSsL.in&date=" + GetTime() + "&mutualkey=" + MesKey));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter=" + Data));
	Http.HttpPost(ServerUrl, Data, RetData);
	return  RetData.c_str();
}
//ע
CString Reg(CString UserName, CString PassWorld,CString QQ) {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=registration.lg&date=" + GetTime() + "&mutualkey=" + MesKey + "&user=" + UserName + "&pwd=" + PassWorld +"&pwdb="+ PassWorld + "&BSphpSeSsL=" + SeSsL + "&maxoror=" + PcHWID+"&qq="+QQ ));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter=" + Data));
	Http.HttpPost(ServerUrl, Data, RetData);
	return RetData.c_str();;
}
//ֵ
CString Pay(CString UserName, CString PassWorld, CString KH,CString KM) {
	CHttpClient Http;
	CString Data;
	string RetData;
	Data = _T(VMProtectDecryptStringA("&api=chong.lg&date=" + GetTime() + "&mutualkey=" + MesKey + "&user=" + UserName + "&usepwd=" + PassWorld + "&BSphpSeSsL=" + SeSsL + "&ka=" + KH + "&pwd=" + KM));
	Data = _T(UrlEncode(Data));
	Data = _T(VMProtectDecryptStringA("&parameter=" + Data));
	Http.HttpPost(ServerUrl, Data, RetData);
	return RetData.c_str();;
}